Resolution: Fixed Affected version:  

Description

Redmine stores some additional columns time entries:

tmonth -> date.month

tyear -> date.year

tweek -> date.cweek

These are used to support group by of the time entries in the reports view. However, there is an edge case which breaks the code.

Consider the following 2 time entry:

field Time Entry 1 Time Entry 2

spent_on 2009-12-12 2010-01-01

tmonth 12 01

tyear 2009 2010

tweek 53 53

Both are in the same week, but in different years. This leads to the second entry to be not displayed often, and if then in the wrong

week, i.e. 2010-53. For the group-by week, instead of date.year, date.cwyear should be used. It results in 2009 for the second

example entry.

The attached patch creates a test for that. It also adds the two time entries above as fixtures. Thus, some other tests had to be

adapted.

Related issues:

Related to Redmine - Defect #4953: "In the past N days" filter displays N+1 days Confirmed 2010-03-01

Has duplicate Redmine - Defect #3060: Week numbers dont match in reports and ... Closed 2009-03-27

Has duplicate Redmine - Defect #2462: Incorrect Week Number in Spent Time Report Closed 2009-01-07

Has duplicate Redmine - Defect #13082: Wrong year in Spent Time Report Closed

Has duplicate Redmine - Defect #13159: Spent Time report - Column Total diffe... Closed

Has duplicate Redmine - Defect #12891: Wrong week number in time entries Closed

Has duplicate Redmine - Defect #12803: Cross-year date range in time tracking... Closed

Associated revisions

Revision 11471 - 2013-02-24 13:18 - Jean-Philippe Lang

Fixed that time entries report by week breaks on edge cases (#5329).

Revision 11565 - 2013-03-09 10:15 - Jean-Philippe Lang

Merged r11471 from trunk (#5329).

History

#1 - 2010-06-04 17:06 - Holger Just

- File 5329_add_year_of_week_to_time_entries.diff added
The attached patch fixes the edge case.

It introduces a new field named twyear to the time entries. It contains the year of the week of the entry. So for the above example, its content for both

entries would be 2009. That way, it is possible to properly group based on weeks.

The included tests run in a current trunk.

#2 - 2010-06-19 18:43 - Holger Just

Just verified that patch again on a current trunk.

It is clean and does what it advertises. I'm just not 100% sure if I managed to find all usages of the week stuff in time_entries. But I'm rather confident,

I did.

#3 - 2010-06-20 00:08 - Holger Just

Okay, after thinking a bit more about it (and fixing some other bugs :)), I conclude that the whole concept of denormalizing the week into the database

for grouping can not properly work.

This is because the week boundaries expected by a user are actually not fixed but depend on her settings. So the actual data set in a group depends

on user settings. To always show the correct result, we would have to

either save at least two variants of the tweek + twyear (for week starting sunday or monday)

or calculate the week using SQL-functions.

I would prefer the second method. Unfortunately, these functions are not fully standardized, so there would be a differentiation needed for different

database engines.

Until then, the attached patch fixes the behavior for the standard commercial week starting on Mondays.

#4 - 2013-01-14 16:04 - Daniel Felix

- Status changed from New to Needs feedback

- Affected version (unused) deleted (devel)

This is another issue regarding the timelog. Someone who can confirm this is still able to reproduce in trunk?

#5 - 2013-01-18 07:38 - Alexey Verin

Please, update patch for version 2.2.1.

My Ruby skill is not enough for this (

#6 - 2013-01-19 04:58 - Mischa The Evil

Daniel Felix wrote:

[...] Someone who can confirm this is still able to reproduce in trunk?

 I can't remember any changes that fixes this issue specifically, though I'm unable to test this on current trunk.

#7 - 2013-01-19 08:53 - Daniel Felix

- Status changed from Needs feedback to Confirmed

Alexey already encountered this big again. (See linked ticket)

This is the confirmation for this issue.

#8 - 2013-02-19 18:18 - Filou Centrinov

Duplicate: #13159

#9 - 2013-02-22 00:08 - Filou Centrinov

- File time_report.rb.patch added

I fixed this issue with a patch. Could we add this to Redmine 2.3?

I verfied my solution for different weeks constellations: Years with 52 and 53 weeks or first week that starts in last year and those which don't.

Everthing works fine.

#10 - 2013-02-22 02:24 - Filou Centrinov

- File time_report.rb.2.patch added
#11 - 2013-02-22 11:54 - Daniel Felix

The patch works on my testsystem too. Thanks for providing this patch!

#12 - 2013-02-22 13:16 - Jean-Philippe Lang

- Target version set to Candidate for next minor release

#13 - 2013-02-24 13:19 - Jean-Philippe Lang

- Status changed from Confirmed to Resolved

- Assignee set to Jean-Philippe Lang

- Target version changed from Candidate for next minor release to 2.3.0

- Resolution set to Fixed

Patch committed in r11471 with a test, thanks.

#14 - 2013-03-04 00:04 - Jean-Philippe Lang

- Subject changed from Group-by week of time entries breaks on edge cases to Time entries report broken on first week of year

#15 - 2013-03-09 10:15 - Jean-Philippe Lang

- Status changed from Resolved to Closed

Merged.

#16 - 2013-03-21 10:40 - Pavel Potcheptsov

Hello, I've updated to 2.3.0.

Is it all right with:

Project -> Overview ->  Report -> Details: Days, Add: User ?

What Days it should display?

In my case it displays days from 2012 year and not the last days, when time was logged in 2013.

Files

functional_test_for_problem.patch 4.11 KB 2010-04-15 Holger Just

5329_add_year_of_week_to_time_entries.diff 6.91 KB 2010-06-04 Holger Just

time_report.rb.patch 863 Bytes 2013-02-21 Filou Centrinov

time_report.rb.2.patch 1.04 KB 2013-02-22 Filou Centrinov
